_uniques = {}


def unique_value(v):
    try:
        return _uniques[v]
    except KeyError:
        _uniques[v] = v
        return v


COUNT = 100_000


def make_items1():
    return [{"columnA": "a string", "columnB": 1234}] * COUNT


def make_items2():
    return list({"column" + "A": "a" + " string", "column" + "B": i + 1234 - i} for i in range(COUNT))


def make_items3():
    return list({
        unique_value("column" + "A"): unique_value("a" + " string"),
        unique_value("column" + "B"): unique_value(i + 1234 - i)
    } for i in range(COUNT))


def count_distinct(o):
    counter = set()
    for item in o:
        for k, v in item.items():
            counter.add(id(k))
            counter.add(id(v))
    return len(counter)


for meth in make_items1, make_items2, make_items3:
    vals = meth()
    print(meth.__name__, len(vals), count_distinct(vals))
